CfnStateMachineAlias L1 construct
Represents a state machine alias . An alias routes traffic to one or two versions of the same state machine.
You can create up to 100 aliases for each state machine.
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_stepfunctions as stepfunctions } from 'aws-cdk-lib';
const cfnStateMachineAlias = new stepfunctions.CfnStateMachineAlias(this, 'MyCfnStateMachineAlias', /* all optional props */ {
deploymentPreference: {
stateMachineVersionArn: 'stateMachineVersionArn',
type: 'type',
// the properties below are optional
alarms: ['alarms'],
interval: 123,
percentage: 123,
},
description: 'description',
name: 'name',
routingConfiguration: [{
stateMachineVersionArn: 'stateMachineVersionArn',
weight: 123,
}],
stateMachineArn: 'stateMachineArn',
});
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_stepfunctions as stepfunctions
cfn_state_machine_alias = stepfunctions.CfnStateMachineAlias(self, "MyCfnStateMachineAlias",
deployment_preference=stepfunctions.CfnStateMachineAlias.DeploymentPreferenceProperty(
state_machine_version_arn="stateMachineVersionArn",
type="type",
# the properties below are optional
alarms=["alarms"],
interval=123,
percentage=123
),
description="description",
name="name",
routing_configuration=[stepfunctions.CfnStateMachineAlias.RoutingConfigurationVersionProperty(
state_machine_version_arn="stateMachineVersionArn",
weight=123
)],
state_machine_arn="stateMachineArn"
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.stepfunctions.*;
CfnStateMachineAlias cfnStateMachineAlias = CfnStateMachineAlias.Builder.create(this, "MyCfnStateMachineAlias")
.deploymentPreference(DeploymentPreferenceProperty.builder()
.stateMachineVersionArn("stateMachineVersionArn")
.type("type")
// the properties below are optional
.alarms(List.of("alarms"))
.interval(123)
.percentage(123)
.build())
.description("description")
.name("name")
.routingConfiguration(List.of(RoutingConfigurationVersionProperty.builder()
.stateMachineVersionArn("stateMachineVersionArn")
.weight(123)
.build()))
.stateMachineArn("stateMachineArn")
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.StepFunctions;
var cfnStateMachineAlias = new CfnStateMachineAlias(this, "MyCfnStateMachineAlias", new CfnStateMachineAliasProps {
DeploymentPreference = new DeploymentPreferenceProperty {
StateMachineVersionArn = "stateMachineVersionArn",
Type = "type",
// the properties below are optional
Alarms = new [] { "alarms" },
Interval = 123,
Percentage = 123
},
Description = "description",
Name = "name",
RoutingConfiguration = new [] { new RoutingConfigurationVersionProperty {
StateMachineVersionArn = "stateMachineVersionArn",
Weight = 123
} },
StateMachineArn = "stateMachineArn"
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnStateMachineAlias := awscdk.Aws_stepfunctions.NewCfnStateMachineAlias(this, jsii.String("MyCfnStateMachineAlias"), &CfnStateMachineAliasProps{
DeploymentPreference: &DeploymentPreferenceProperty{
StateMachineVersionArn: jsii.String("stateMachineVersionArn"),
Type: jsii.String("type"),
// the properties below are optional
Alarms: []*string{
jsii.String("alarms"),
},
Interval: jsii.Number(123),
Percentage: jsii.Number(123),
},
Description: jsii.String("description"),
Name: jsii.String("name"),
RoutingConfiguration: []interface{}{
&RoutingConfigurationVersionProperty{
StateMachineVersionArn: jsii.String("stateMachineVersionArn"),
Weight: jsii.Number(123),
},
},
StateMachineArn: jsii.String("stateMachineArn"),
})
Initializer
new CfnStateMachineAlias(scope: Construct, id: string, props?: CfnStateMachineAliasProps)
CfnStateMachineAlias(scope: Construct, id: str, props: typing.Optional[CfnStateMachineAliasProps] = None)
new CfnStateMachineAlias(Construct scope, String id, CfnStateMachineAliasProps props)
new CfnStateMachineAlias(Construct scope, string id, CfnStateMachineAliasProps? props = null)
NewCfnStateMachineAlias(Scope Construct, Id *string, Props CfnStateMachineAliasProps)
Construct Props
deploymentPreferenceoptionalIResolvable | CfnStateMachineAlias.DeploymentPreferencePropertydeployment_preferenceoptionaltyping.Union[IResolvable, DeploymentPreferenceProperty]deploymentPreferenceoptionalIResolvableDeploymentPreferenceoptionalIResolvableDeploymentPreferenceoptionalinterface{}#notes
These settings include Alarms , Interval , Percentage , StateMachineVersionArn , and Type .
CloudFormation automatically shifts traffic from the version an alias currently points to, to a new state machine version that you specify.
RoutingConfigurationandDeploymentPreferenceare mutually exclusive properties. You must define only one of these properties.
Based on the type of deployment you want to perform, you can specify one of the following settings:
LINEAR- Shifts traffic to the new version in equal increments with an equal number of minutes between each increment.
For example, if you specify the increment percent as 20 with an interval of 600 minutes, this deployment increases traffic by 20 percent every 600 minutes until the new version receives 100 percent of the traffic. This deployment immediately rolls back the new version if any Amazon CloudWatch alarms are triggered.
ALL_AT_ONCE- Shifts 100 percent of traffic to the new version immediately. CloudFormation monitors the new version and rolls it back automatically to the previous version if any CloudWatch alarms are triggered.CANARY- Shifts traffic in two increments.
In the first increment, a small percentage of traffic, for example, 10 percent is shifted to the new version. In the second increment, before a specified time interval in seconds gets over, the remaining traffic is shifted to the new version. The shift to the new version for the remaining traffic takes place only if no CloudWatch alarms are triggered during the specified time interval.
descriptionoptionalstringdescriptionoptionalstrdescriptionoptionalStringDescriptionoptionalstringDescriptionoptional*string#If you don't provide a name, it uses an automatically generated name based on the logical ID.
routingConfigurationoptionalIResolvable | IResolvable | CfnStateMachineAlias.RoutingConfigurationVersionProperty[]routing_configurationoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, RoutingConfigurationVersionProperty]]]routingConfigurationoptionalIResolvableRoutingConfigurationoptionalIResolvableRoutingConfigurationoptionalinterface{}#notes
Routing configuration splits StartExecution requests between one or two versions of the same state machine.
Use RoutingConfiguration if you want to explicitly set the alias weights . Weight is the percentage of traffic you want to route to a state machine version.
RoutingConfigurationandDeploymentPreferenceare mutually exclusive properties. You must define only one of these properties.
stateMachineArnoptionalstringstate_machine_arnoptionalstrstateMachineArnoptionalStringStateMachineArnoptionalstringStateMachineArnoptional*string#Properties
For example, arn:aws:states:us-east-1:123456789012:stateMachine:myStateMachine:PROD .
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#deploymentPreferencemay be undefinedIResolvable | CfnStateMachineAlias.DeploymentPreferencePropertydeployment_preferencemay be undefinedtyping.Union[IResolvable, DeploymentPreferenceProperty]deploymentPreferencemay be undefinedIResolvableDeploymentPreferencemay be undefinedIResolvableDeploymentPreferencemay be undefinedinterface{}#descriptionmay be undefinedstringdescriptionmay be undefinedstrdescriptionmay be undefinedStringDescriptionmay be undefinedstringDescriptionmay be undefined*string#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
namemay be undefinedstringnamemay be undefinedstrnamemay be undefinedStringNamemay be undefinedstringNamemay be undefined*string#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
routingConfigurationmay be undefinedIResolvable | IResolvable | CfnStateMachineAlias.RoutingConfigurationVersionProperty[]routing_configurationmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, RoutingConfigurationVersionProperty]]]routingConfigurationmay be undefinedIResolvableRoutingConfigurationmay be undefinedIResolvableRoutingConfigurationmay be undefinedinterface{}#CfnElements must be defined within a stack scope (directly or indirectly).
stateMachineAliasRefStateMachineAliasReferencestate_machine_alias_refStateMachineAliasReferencestateMachineAliasRefStateMachineAliasReferenceStateMachineAliasRefStateMachineAliasReferenceStateMachineAliasRefStateMachineAliasReferencerequired#stateMachineArnmay be undefinedstringstate_machine_arnmay be undefinedstrstateMachineArnmay be undefinedStringStateMachineArnmay be undefinedstringStateMachineArnmay be undefined*string#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForStateMachineAlias(resource: IStateMachineAliasRef): string@staticmethod def arn_for_state_machine_alias(resource: IStateMachineAliasRef) -> strpublic static String arnForStateMachineAlias(IStateMachineAliasRef resource)public static string ArnForStateMachineAlias(IStateMachineAliasRef resource)func ArnForStateMachineAlias(Resource IStateMachineAliasRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isCfnStateMachineAlias(x: any): boolean@staticmethod def is_cfn_state_machine_alias(x: Any) -> boolpublic static Boolean isCfnStateMachineAlias(Object x)public static bool IsCfnStateMachineAlias(object x)func IsCfnStateMachineAlias(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.